from abc import ABC, abstractmethod

from cpl_query.extension import List

from bot_data.model.scheduled_event import ScheduledEvent


class ScheduledEventRepositoryABC(ABC):
    @abstractmethod
    def __init__(self):
        pass

    @abstractmethod
    def get_scheduled_events(self) -> List[ScheduledEvent]:
        pass

    @abstractmethod
    def get_scheduled_event_by_id(self, id: int) -> ScheduledEvent:
        pass

    @abstractmethod
    def get_scheduled_events_by_server_id(self, id: int) -> List[ScheduledEvent]:
        pass

    @abstractmethod
    def add_scheduled_event(self, scheduled_event: ScheduledEvent):
        pass

    @abstractmethod
    def update_scheduled_event(self, scheduled_event: ScheduledEvent):
        pass

    @abstractmethod
    def delete_scheduled_event(self, scheduled_event: ScheduledEvent):
        pass
